function ServiceDecl()
{
	this.service = "";
    this.items = null;
    
    this._comboItems = null;
}

ServiceDecl.PREMIUM = "PREMIUM";
ServiceDecl.SUBSCRIPTION = "SUBSCRIPTION";
ServiceDecl.BUY_CALCULATIONS = "BUY_CALCULATIONS";
ServiceDecl.BUY_TEMPLE_POINTS = "BUY_TEMPLE_POINTS";
ServiceDecl.CLEAR_BETRAYER = "CLEAR_BETRAYER";
ServiceDecl.VACATION = "VACATION";

ServiceDecl.CLOSE_GATE = "CLOSE_GATE";
ServiceDecl.FINISH_BUILDING = "FINISH_BUILDING";
ServiceDecl.MAX_DEFENCE = "MAX_DEFENCE";
ServiceDecl.BUILDINGS_DURABILITY = "BUILDINGS_DURABILITY";
ServiceDecl.HOUSES = "HOUSES";

ServiceDecl.prototype.isHidden = function()
{
    if (!this.items)
    {
        return true;
    }
    for(var i = 0; i < this.items.length; i++)
    {
        if(this.items[i].hidden)
        {
            return true;
        }
    }
    return false;
}

ServiceDecl.prototype.getComboItems = function() {
    if (!this._comboItems) {
        this._comboItems = [];
        for (var i=0; i<this.items.length; i++)
        {
            this._comboItems.push(this.getComboItem(i));
        }
        return this._comboItems;
    }
    return this._comboItems;
}

ServiceDecl.prototype.getComboItem = function(level)
{
    return this.items[level].getLabelText();
}

ServiceDecl.prototype.getRewardParams = function(level)
{
    return this.items[level].getRewardParams();
}

ServiceDecl.prototype.getDescription = function(level)
{
    var key = "SERVICE_DESC_" + this.service;
    var result = I18.getMegaString(key, this.getRewardParams(level));
    return key == result ? null : result;
}
