function XY(x, y, u)
{
	this.x = x ? x : 0;
	this.y = y ? y : 0;
	this.u = !!u;
}

XY.prototype.__CLS__ = 'game.model.XY';
XY.prototype.distanceTo = function(another)
{
	var dx = another.x - this.x;
	var dy = another.y - this.y;
	return Math.sqrt(dx * dx + dy * dy);
}

XY.prototype.isInRadiusFrom = function(another, radius)
{
	return Math.max(Math.abs(another.x - this.x), Math.abs(another.y - this.y)) <= radius;
}

XY.prototype.toString = function()
{
	return "[" + (this.x + 1) + "-" + (this.y + 1) + (this.u ? "#":"") + "]";
}

XY.prototype.equals = function(o)
{
	if (o == null)
	{
		return false;
	}
	return this.x == o.x && this.y == o.y && this.u == o.u;
}

XY.prototype.equalsXY = function(x, y)
{
	return this.x == x && this.y == y;
}

XY.prototype.otherPlane = function()
{
	return new XY(this.x, this.y, !this.u);
}