function Texts()
{
	
};
	
Texts.t = function(key/*:String*/)
{
	var value = Texts.tOrNull(key);
	return value != null ? value : "{" + key + "}";
}
   
Texts.tOrNull = function(key/*:String*/)
{
	return FConfig.clientTexts.getValueOrNull(key);
}

Texts.skillName = function(slotName/*:String*/)
{
	return Texts.spellName(slotName);
}
   
Texts.spellName = function(name/*:String*/)
{
	return name == null ? "?" : Texts.t("SPELL_" + name + "_NAME");
}

Texts.artifactSetName = function(name/*:String*/)
{
    return name == null ? "?" : Texts.t("SET_" + name + "_NAME");
}

Texts.crystalName = function(name/*:String*/)
{
    return Texts.spellName(name);
}

Texts.runeName = function(rune)
{
    return Texts.t(rune.toUpperCase() + "_NAME");
}

Texts.artifactName = function(decl/*:ArtifactDeclaration*/)
{
    switch (decl.type.name) {
        case ArtifactType.SCROLL.name: return I18.f("SCROLL_NAME") + "  " + Texts.spellName(decl.spell);
		case ArtifactType.MANA_BOTTLE.name: return Texts.t("SPELL_ELEKSIR_MANI_NAME");
		case ArtifactType.EXP_BOTTLE.name: return Texts.t("SPELL_ELEKSIR_OPITA_NAME");
		case ArtifactType.ARTIFACT.name: return Texts.t("ARTIFACT_" + decl.name.toUpperCase());
		case ArtifactType.RUNE.name: return Texts.runeName(decl.name);
    	case ArtifactType.CRYSTAL.name: return Texts.crystalName(decl.name);
		case ArtifactType.RECIPE.name: return Texts.spellName(decl.name);
	}
    throw new Error("Cannot find name for artifact: " + decl.name);
}

Texts.artifactTypeNameLvl = function(type/*:ArtifactType*/, level/*:int*/)
{
	switch (type.name) {
		case ArtifactType.SCROLL.name: return I18.f("SCROLL_NAME") + "  " + " " + I18.f("LVL_X",level);
		case ArtifactType.MANA_BOTTLE.name: return Texts.t("SPELL_ELEKSIR_MANI_NAME");
		case ArtifactType.EXP_BOTTLE.name: return Texts.t("SPELL_ELEKSIR_OPITA_NAME");
		case ArtifactType.ARTIFACT.name: return I18.f("ARTIFACT_NAME") + "  " + " " + I18.f("LVL_X",level);
		case ArtifactType.RUNE.name: return I18.f("RUNE");
		case ArtifactType.CRYSTAL.name: return I18.f("CRYSTALS");
		case ArtifactType.RECIPE.name: return I18.f("RECIPE");
	}
	throw new Error("Cannot find name for artifact type: " + type);
};

Texts.artifactNameLvl = function(decl/*:ArtifactDeclaration*/)
{
    return Texts.artifactName(decl) + " " + I18.f("LVL_X",decl.level);
}