function OuterEstateGateView()
{
	this.estate = null;
    this.onGateClick = null;
}

OuterEstateGateView.prototype.__construct = function()
{
	this.DOM.style.position = "absolute";
	COM.bindExclusiveClick(this.gateImage, $.proxy(this.gateClick, this));
}

OuterEstateGateView.prototype.update = function(estate)
{
    this.estate = estate;
    UI.show(estate.isGateChanging(), [this.countDownContainer]);
    if (UI.show(this.estate.location.u, [this.undergroundGateImage])) {
        this.undergroundGateImage.src = STATIC_URL + Assets.OuterBuildings.MINE_BLACK;
    }
    if (UI.show(!this.estate.location.u, [this.gateImage])) {
        this.gateImage.src = STATIC_URL + (estate.isGateClosed() ? Assets.OuterBuildings.PIT_GATE_CLOSED : Assets.OuterBuildings.PIT_GATE_OPEN);
    }
}

OuterEstateGateView.stateText = function(e, state)
{
    return I18.getEntranceStateText(e.isOuterEstate, state);
}

OuterEstateGateView.prototype.tick = function()
{
    if (this.countdown.style.display != "none")
    {
        var now = FEstate.tickNowForEstate(this.estate);
        this.countdown.innerHTML = Tick.toTimeLeft(this.estate.gateChangeTick - now);
		
		this.endTime.innerHTML = (this.estate.isGateOpen() ? OuterEstateGateView.stateText(this.estate, "IS_CLOSING") : OuterEstateGateView.stateText(this.estate, "IS_OPENING")) + " " + DateUtils.formatWithSeconds(Tick.toMs(this.estate.gateChangeTick));
    }
    else this.endTime.innerHTML = "";
}

OuterEstateGateView.prototype.brightenGate = function(e)
{
    //Effects.brighten(gateImage);
}

OuterEstateGateView.prototype.darkenGate = function(e)
{
    //Effects.removeTint(gateImage);
}

OuterEstateGateView.prototype.gateClick = function(e)
{
    this.onGateClick(this);
}

OuterEstateGateView.prototype.onGateTip = function(e)
{
    //e.toolTip = GateTip.create(estate);
}