function LoanSharkDialog()
{
    callParentConstructor(LoanSharkDialog.prototype, this);
}

extendClass(LoanSharkDialog.prototype, Dialog.prototype);

LoanSharkDialog.prototype.__construct = function()
{
    COM.bindExclusiveClick(this.takeLoanButton, $.proxy(this.takeLoan, this));
    COM(this.loanAvailableTillLabel).value = Tick.TICK_INFINITY;
    COM(this.loanAvailableTillLabel).handler = $.proxy(this.onLoanTimeout, this);
    COM(this.loanDueAtLabel).value = Tick.TICK_INFINITY;
    COM(this.loanDueAtLabel).handler = $.proxy(this.onLoanTimeout, this);
}
LoanSharkDialog.prototype.onShow = function()
{
    Events.onFUserUpdated.add(this, this.doUpdate);
    this.doUpdate(FUser.CURRENT_USER);
};

LoanSharkDialog.prototype.onClose = function()
{
    Events.onFUserUpdated.remove(this, this.doUpdate);
}

LoanSharkDialog.prototype.doUpdate = function(currentUser)
{
    const dialogCaption = $(this.DOM).find('*[name=caption]');
    const loanShark = currentUser.loanShark;
    if (!loanShark.isVisible()) {
        this.close();
    } else if (loanShark.isAwaitingPayment()) {
        dialogCaption.html(I18.f('LOAN_SHARK_PAY_TITLE'));
        UI.show(false, [this.takeLoanBox]);
        UI.show(true, [this.payLoanBox]);
        this.payDescription.innerHTML = I18.flow('LOAN_SHARK_PAY_DESCRIPTION');
        COM(this.owedPearlsLabel).value = loanShark.pearls;
        COM(this.loanDueAtLabel).value = loanShark.loanDueAt;
        COM(this.loanAvailableTillLabel).value = Tick.TICK_INFINITY;
    } else {
        dialogCaption.html(I18.f('LOAN_SHARK_TAKE_TITLE'));
        UI.show(true, [this.takeLoanBox]);
        UI.show(false, [this.payLoanBox]);
        this.takeDescription.innerHTML = I18.flow('LOAN_SHARK_TAKE_DESCRIPTION');
        COM(this.loanPearlsLabel).value = loanShark.pearls;
        COM(this.loanAvailableTillLabel).value = loanShark.visibleTill;
        COM(this.loanDueAtLabel).value = Tick.TICK_INFINITY;
    }
}

LoanSharkDialog.prototype.takeLoan = function()
{
    Alert.create(I18.f('LOAN_SHARK_TAKE_CONFIRMATION'), '', function() {
        if (!Quarantine.contains('takeLoanButton'))
        {
            Quarantine.put('takeLoanButton');
            Service.city.callMethod('takeLoan', [GlobalSelectionCitiesCombo.selectedCityId]);
        }
    });
}

LoanSharkDialog.prototype.onLoanTimeout = function()
{
    this.close();
    Service.user.callMethod('getCurrentUser', []);
}

LoanSharkDialog.popup = function()
{
    COM.create("LoanSharkDialog").popup();
}
