function PassiveDescription()
{
	this.__defineGetter__('titleText', this.getTitleText);
	this.__defineSetter__('titleText', this.setTitleText);
}

PassiveDescription.prototype.__construct = function()
{
	this.title.innerHTML = I18.f('PASSIVE_SKILLS');
}

PassiveDescription.prototype.getTitleText = function()
{
    return this.title.innerHTML;
}

PassiveDescription.prototype.setTitleText = function(titleText)
{
    if (UI.show(titleText != null, [this.title])) {
        this.title.innerHTML = titleText;
    }
}

PassiveDescription.prototype.setTitleStyle = function(titleStyle)
{
    this.title.style = titleStyle;
}

PassiveDescription.prototype.update = function(actions, filterActions) {
    this.actionsText.innerHTML = '';
    if (actions) {
        if (filterActions == null) {
            EffectsView.createDescriptiveView(this.actionsText, actions.dtoActions, false, true, false, true);
        } else {
            var filtered = [];
            for (var i = 0, len = actions.dtoActions.length; i < len; i++) {
                var reward = actions.dtoActions[i];
                if (!checkContains(filterActions.dtoActions, reward)) {
                    filtered.addItem(reward);
                }
            }
            EffectsView.createDescriptiveView(this.actionsText, filtered, false, true, false, true);
        }
    }
};


function checkContains(array, value) {
    for (var i = 0, len = array.length; i < len; i++) {
        var v = array[i];
        if (v.rewardType == value.rewardType && v.rewardParams.toString() == value.rewardParams.toString()) {
            return true;
        }
    }
    return false;
}
