function CoordsChooser()
{
	this.showZ = true;
	this.showU = false;
	this.enableXY = true;
	
	this.__defineSetter__('caption', function(value)
	{
		if(value)
		{
			this.textLabel.style.display = "";
			this.textLabel.innerHTML = value;
		}
		else
		{
			this.textLabel.style.display = "none";
		}
	})

	this.__defineGetter__('enableInput', function()
	{
	    return !(COM(this.stepX).disabled && COM(this.stepY).disabled && COM(this.stepZ).disabled);
	});
	this.__defineSetter__('enableInput', this._enableInput);
}

CoordsChooser.prototype.showZ = true;
CoordsChooser.prototype.showU = false;
CoordsChooser.prototype.enableXY = true;

CoordsChooser.prototype.__construct = function()
{
	if (this.DOM.hasAttribute('showZ'))
	{
		this.showZ = (this.DOM.getAttribute('showZ') == 'true');
	}
	if (this.DOM.hasAttribute('showU'))
	{
		this.showU = (this.DOM.getAttribute('showU') == 'true') && FConfig.UNDERGROUND_ENABLED;
	}
	if (this.DOM.hasAttribute('enableXY'))
	{
		this.enableXY = (this.DOM.getAttribute('enableXY') == 'true');
	}
	
	COM(this.stepX).max = FConfig.EMPIRE_SIZE.x;
	COM(this.stepY).max = FConfig.EMPIRE_SIZE.y;

	var s2 = COM(this.groundUnderground);
	s2.addOption(0, I18.f("TERRAIN_GROUND"));
	s2.addOption(1, I18.f("TERRAIN_UNDERGROUND"));
	s2.refresh();
	s2.selectedIndex = 0;

	this.update();
}

CoordsChooser.create = function(text, mode3d, lockTarget)
{
    if (typeof mode3d == 'undefined') mode3d = true;
    var chooser = COM.create('CoordsChooser');
    
    chooser.caption = text;
    chooser.showZ = mode3d;
    
    if (lockTarget) 
    {
        chooser.setCoordsXYZ(lockTarget);
        chooser.enableInput = false;
    }
    
    chooser.update();
    
    return chooser;
}

CoordsChooser.prototype.update = function()
{
	UI.show(this.showZ, [this.stepZ]);
	UI.show(this.showU, [this.groundUnderground]);
	if (!this.enableXY)
	{
	    COM(this.stepX).disabled = true;
	    COM(this.stepY).disabled = true;
	}
}

CoordsChooser.prototype.getCoordsXY = function()
{
    return new XY(COM(this.stepX).value - 1, COM(this.stepY).value - 1, COM(this.groundUnderground).selectedIndex == 0 ? false : true);
}

CoordsChooser.prototype.getCoordsXYZ = function()
{
    return new XYZ(COM(this.stepX).value - 1, COM(this.stepY).value - 1, COM(this.stepZ).value - 1, COM(this.groundUnderground).selectedIndex == 0 ? false : true);
}

CoordsChooser.prototype.setCoordsXYZ = function(coords)
{
    this.setCoordsXY(coords);
    COM(this.stepZ).value = coords.z + 1;
	COM(this.groundUnderground).selectedIndex = coords.u ? 1 : 0;
}

CoordsChooser.prototype.setCoordsXY = function(coords)
{
    COM(this.stepX).value = coords.x + 1;
    COM(this.stepY).value = coords.y + 1;
	COM(this.groundUnderground).selectedIndex = coords.u ? 1 : 0;
}

CoordsChooser.prototype._enableInput = function(enabled)
{
    COM(this.stepX).disabled = !enabled || !this.enableXY;
    COM(this.stepY).disabled = !enabled || !this.enableXY;
    COM(this.stepZ).disabled = !enabled;
    COM(this.groundUnderground).disabled = !enabled;
}
