function OnDebtVacationDialog()
{
    callParentConstructor(OnDebtVacationDialog.prototype, this);
}

extendClass(OnDebtVacationDialog.prototype, Dialog.prototype);

OnDebtVacationDialog.prototype.__construct = function()
{
    this.userCanClose = false;

    const user = FUser.CURRENT_USER;
    const loanShark = user.loanShark;
    this.descriptionText.innerHTML = I18.f("LOAN_SHARK_OVERDUE_DESCRIPTION");
    this.overdueDebtBox.append(I18.box("LOAN_SHARK_OVERDUE_DEBT", loanShark.pearls - user.pearl));
    COM(this.deleteAvatarTimeLabel).value = loanShark.debtVacationEndTick;
    COM(this.deleteAvatarTimeLabel).handler = $.proxy(this.onDeleteTimout, this);
    UI.show(true, [this.deletionPendingBox]);
    UI.show(false, [this.deletionInProgressBox]);
}

OnDebtVacationDialog.prototype.onShow = function()
{
    Events.onFUserUpdated.add(this, this.onUserUpdated);
};

OnDebtVacationDialog.prototype.onClose = function()
{
    Events.onFUserUpdated.remove(this, this.onUserUpdated);
    OnVacationDialog.instance = null;
}

OnDebtVacationDialog.prototype.onUserUpdated = function(user)
{
    if (!user.loanShark.isOwed())
    {
        this.close()
    }
}

OnDebtVacationDialog.prototype.onDeleteTimout = function()
{
    UI.show(false, [this.deletionPendingBox]);
    UI.show(true, [this.deletionInProgressBox]);
}

OnDebtVacationDialog.popup = function()
{
    if (!OnVacationDialog.instance)
    {
        OnVacationDialog.instance = COM.create("OnDebtVacationDialog");
        OnVacationDialog.instance.popup();
    }

}
