function FArtifact(declaration)
{
	if (declaration)
	{
		if (!(declaration instanceof ArtifactDeclaration))
		{
			delaration = declaration.declaration;
		}
	}
	
	this._declaration = declaration;
	this.runes = [];
	
	this.__defineGetter__('declaration', function()
	{
	    return this._declaration ? this._declaration : ArtifactDeclaration.UNKNOWN_ARTIFACT;
	});
	
	this.__defineSetter__('declaration', function(value)
	{
	    this._declaration = value;
	});

	this.__defineGetter__('price', function()
	{
	    var price = this.isTimerActive() ? this.declaration.buyOutCost.pearl : this.declaration.cost.pearl;
	    if (this.upgradesCount > 0) 
	    {
	        price *= FConfig.UPGRADED_ARTIFACT_COST_MULTIPLICATOR[this.upgradesCount - 1]
	    }
	    return price;
	});
}

FArtifact.prototype.id = 0;
FArtifact.prototype.fullSet = false;
FArtifact.prototype.setItemsCount = 0;
FArtifact.prototype.runes = [];
FArtifact.prototype.runeWord = [];
FArtifact.prototype._declaration = null;
FArtifact.prototype.upgradesCount = 0;
FArtifact.prototype.convertedToDeclaration = null;
FArtifact.prototype.tillTick = 0;
FArtifact.prototype.buyFromTick = 0;
FArtifact.prototype.cooldownTillTick = 0;

FArtifact.prototype.prepareForRequest = function()
{
	return {
		__CLS__: this.__CLS__,
		id: this.id,
		fullSet: this.fullSet,
		upgradesCount: this.upgradesCount,
		declaration: this.declaration,
		price: this.price
	};
}

FArtifact.prototype.isStackableTo = function(artifact)
{
    return this.declaration && this.declaration.name == artifact.declaration.name && this.declaration.isStackable();
}

FArtifact.prototype.isUpgradable = function()
{
    if (!this._declaration) 
    {
        return false;
    }
    return this.upgradesCount == 0 && this._declaration.type.name == ArtifactType.ARTIFACT.name;
}

FArtifact.prototype.setItemsCountCompatible = function()
{
	if (!this.setItemsCount && this.fullSet && this._declaration) {
		return ArtifactDeclaration.maxSetItemsCount(this.declaration.setPassive);
	}
	return this.setItemsCount;
}

FArtifact.prototype.isTimerActive = function()
{
	return this.tillTick > 0;
}

FArtifact.prototype.canSell = function()
{
	return !this.isTimerActive();
}

FArtifact.prototype.canBuyOut = function()
{
	return this.isTimerActive() && this.buyFromTick <= Tick.now();
}
