/*
public class MissionDigDialog extends MilitaryMissionDialog {
    override protected function setupParentComponentsProperties():void {
        parentDialog.goal.text = I18.MISSION_GOAL_DIG.f();
    }

    override protected function setupParentComponentsVisibility():void {
        showTravelMissionsComponents();
        UI.show(true, [parentDialog.goalHBox, parentDialog.missionCostBox]);
        parentDialog.etaGridRow.showReturnTime = true;
    }

    override protected function createMissionOrder():void {
        missionOrder = new MissionDigOrder();
    }

    override protected function checkMissionConstraints(estate:FEstate):Boolean {
        if (!super.checkMissionConstraints(estate)) {
            return false;
        } else if (!FUser.CURRENT_USER.tournamentGrotto.isRunning) {
            setNotification(I18.MISSION_START_ERROR_FIELD_WITH_KNOWN_GRAFFITI_REQUIRED.f());
            return false;
        } else if (FUser.CURRENT_USER.tournamentGrotto.isTreasureFound) {
            setNotification(I18.MISSION_START_ERROR_TREASURE_ALREADY_FOUND.f());
            return false;
        } else if (Tick.now() < FUser.CURRENT_USER.tournamentGrotto.digAvailableTick) {
            setNotification(I18.MISSION_START_ERROR_CANNOT_DIG_WARMUP_OR_COOLDOWN.f(0, Tick.toTimeFutureSeconds(FUser.CURRENT_USER.tournamentGrotto.digAvailableTick)));
            return false;
        } else if (!equalizer.heroSelected) {
            setNotification(I18.MISSION_START_ERROR_HERO_IS_REQUIRED.f());
            return false;
        }
        return true;
    }
}}
*/


function MissionDigDialog()
{
	callParentConstructor(MissionDigDialog.prototype, this);
}

extendClass(MissionDigDialog.prototype, MilitaryMissionDialog.prototype);

MissionDigDialog.prototype.setupParentComponentsProperties = function()
{
    this.parentDialog.setCaption(I18.f("MISSION_GOAL_DIG"));
}

MissionDigDialog.prototype.setupParentComponentsVisibility = function()
{
    this.showTravelMissionsComponents();
    UI.show(true, [this.parentDialog.goalHBox, this.parentDialog.missionCostBox]);
    this.parentDialog.etaGridRow.showReturnTime = true;

}

MissionDigDialog.prototype.createMissionOrder = function()
{
    this.missionOrder = new MissionDigOrder();
}

MissionDigDialog.prototype.checkMissionConstraints = function(estate)
{
    if (!superMethod(MissionDigDialog.prototype, "checkMissionConstraints", this)(estate)) {
        return false;
    }
    else if (!FUser.CURRENT_USER.tournamentGrotto.isRunning) {
        this.setNotification(I18.f("MISSION_START_ERROR_FIELD_WITH_KNOWN_GRAFFITI_REQUIRED"));
        return false;
    }
    else if (FUser.CURRENT_USER.tournamentGrotto.isTreasureFound) {
        this.setNotification(I18.f("MISSION_START_ERROR_TREASURE_ALREADY_FOUND"));
        return false;
    }
    else if (Tick.now() < FUser.CURRENT_USER.tournamentGrotto.digAvailableTick) {
        this.setNotification(I18.f("MISSION_START_ERROR_CANNOT_DIG_WARMUP_OR_COOLDOWN", 0, Tick.toTimeFutureSeconds(FUser.CURRENT_USER.tournamentGrotto.digAvailableTick)));
        return false;
    } else if (!COM(this.equalizer).heroSelected) {
        this.setNotification(I18.f("MISSION_START_ERROR_HERO_IS_REQUIRED"));
        return false;
    }
    return true;
}
